import 'package:rasadyar_chicken/data/models/response/user_info/user_info_model.dart';
import 'package:rasadyar_chicken/data/models/response/user_profile_model/user_profile_model.dart';
import 'package:rasadyar_core/core.dart';

import 'auth_remote.dart';

class AuthRemoteDataSourceImp extends AuthRemoteDataSource {
  final DioRemote _httpClient;
  final String _BASE_URL = 'auth/api/v1/';

  AuthRemoteDataSourceImp(this._httpClient);

  @override
  Future<UserProfileModel?> login({required Map<String, dynamic> authRequest}) async {
    var res = await _httpClient.post<UserProfileModel?>(
      '/api/login/',
      data: authRequest,
      fromJson: UserProfileModel.fromJson,
      headers: {'Content-Type': 'application/json'},
    );
    return res.data;
  }

  @override
  Future<void> logout() {
    // TODO: implement logout
    throw UnimplementedError();
  }

  @override
  Future<bool> hasAuthenticated() async {
    final response = await _httpClient.get<bool>(
      '$_BASE_URL/login/',
      headers: {'Content-Type': 'application/json'},
    );

    return response.data ?? false;
  }

  @override
  Future<UserInfoModel?> getUserInfo(String phoneNumber) async {
    var res = await _httpClient.post<UserInfoModel?>(
      'https://userbackend.rasadyaar.ir/api/send_otp/',
      data: {"mobile": phoneNumber, "state": ""},
      fromJson: UserInfoModel.fromJson,
      headers: {'Content-Type': 'application/json'},
    );
    return res.data;
  }

  @override
  Future<void> submitUserInfo(Map<String, dynamic> userInfo)async {
    var res = await _httpClient.post(
      '/steward-app-login/',
      data: userInfo,
      headers: {'Content-Type': 'application/json'},
    );
  }
}
